Subject: Cache HEAD response headers of upload_object

Description

When using client.upload_object, the first HTTP request to the server is a HEAD request. This request is used to obtain block size and

other meta-information about the server, as well as a check that the server is up and running. This normally returns a "204 No Content"

response with the appropriate headers, and the object is subsequently uploaded using several PUT and POST requests.

When issuing a second client.upload_object call, the HEAD request is repeated to obtain the meta-information from the server a second

time. As the client object upon which the method is called is container- and server- specific with this information provided to it during

construction, this request is redundant. Please modify it so that the response of the HEAD request (the "x-container-block-hash" header)

is cached during the first object upload and subsequent calls to client.upload_object() only issue PUT and POST requests directly

without a leading HEAD request. The first PUT request can also be used to determine whether the server is up and running.

Related issues:

blocks ./kamaki - Feature # 3735: Limit container info requests to one per up... Closed 05/15/2013 05/15/2013

Associated revisions

Revision 76ebf97c - 05/15/2013 02:06 pm - Stavros Sachtouris

Add a container_infor_cache param to upload_object

Each upload involves a request that retrieves block size and hash information.

In higher level applications, this request is redudant after the first upload.

This feature allows higher level operations to cache retrieved container info

in a session.

Refs: #3707

Revision 0ef0db9f - 05/15/2013 02:23 pm - Stavros Sachtouris

Update unitest to include container_info_cache

Refs: 3707

Revision 14c72dbd - 05/15/2013 03:12 pm - Stavros Sachtouris

Adjust pithos livetest to use container_info_cache

Refs: #3707

Revision 9550a759 - 05/15/2013 03:13 pm - Stavros Sachtouris

Update changelog for upload's container_info_cache
Refs: #3707

History

#1 - 05/15/2013 01:37 pm - Stavros Sachtouris

- Due date set to 05/16/2013

- Estimated time set to 2.00

#2 - 05/15/2013 03:14 pm - Stavros Sachtouris

- Status changed from New to Resolved

- % Done changed from 0 to 100

#3 - 05/15/2013 03:47 pm - Stavros Sachtouris

- Status changed from Resolved to Closed
